import {BasicColumn} from '/@/components/Table';
import {FormSchema} from '/@/components/Table';
import { rules} from '/@/utils/helper/validator';
import { render } from '/@/utils/common/renderUtils';
//列表数据
export const columns: BasicColumn[] = [
    {
    title: '接口地址',
    align:"center",
    dataIndex: 'url'
   },
   {
    title: '打印机用户',
    align:"center",
    dataIndex: 'user'
   },
   {
    title: 'UKEY',
    align:"center",
    dataIndex: 'userKey'
   },
   {
    title: '打印机编号',
    align:"center",
    dataIndex: 'sn'
   },
   {
    title: '打印机',
    align:"center",
    dataIndex: 'snList'
   },
   {
    title: '加油站名称',
    align:"center",
    dataIndex: 'name'
   },
];
//查询数据
export const searchFormSchema: FormSchema[] = [
];
//表单数据
export const formSchema: FormSchema[] = [
  {
    label: '接口地址',
    field: 'url',
    component: 'Input',
  },
  {
    label: '打印机用户',
    field: 'user',
    component: 'Input',
  },
  {
    label: 'UKEY',
    field: 'userKey',
    component: 'Input',
  },
  {
    label: '打印机编号',
    field: 'sn',
    component: 'Input',
  },
  {
    label: '打印机',
    field: 'snList',
    component: 'Input',
  },
  {
    label: '加油站名称',
    field: 'name',
    component: 'Input',
  },
];
