import {BasicColumn} from '/@/components/Table';
import {FormSchema} from '/@/components/Table';
import { rules} from '/@/utils/helper/validator';
import { render } from '/@/utils/common/renderUtils';
//列表数据
export const columns: BasicColumn[] = [
    {
    title: '加油站',
    align:"center",
    dataIndex: 'shopId_dictText'
   },
   {
    title: '金融',
    align:"center",
    dataIndex: 'price'
   },
];
//查询数据
export const searchFormSchema: FormSchema[] = [
	{
      label: "加油站",
      field: "shopId",
      component: 'JSearchSelect',
      componentProps:{
         dict:"cheer_shop,name,id"
      },
      colProps: {span: 6},
 	},
];
//表单数据
export const formSchema: FormSchema[] = [
  {
    label: '加油站',
    field: 'shopId',
    component: 'JSearchSelect',
    componentProps:{
       dict:"cheer_shop,name,id"
    },
  },
  {
    label: '金融',
    field: 'price',
    component: 'InputNumber',
  },
];
